; Funktion um Hhenlinien "auszudnnen" Autor gerdecke.de
;
;
; Von Fremdsystemen kommende Hhenlinien haben sehr oft alle 20cm einen Sttzpunkt.
; Die Funktion entfernt unntige Sttzpunkte
; festzulegen sind ein mindestabstand der nicht berschritten werden soll (bei groen Objekten ca 10m) und ein
; Brechwinkel (empfohlen <= 2gon)
;;; solange sich die Linie nicht um mehr als diesen Winkel verndert werden Punkte entfernt.
;
; Die Unterfunktionen zur Polylinienbearbeitung entstammen einer Funktionssammlung "PLVERT" von ?????? ( leider keine ; Autorangaben  enthalten nur der
; Hinweis da Teile von MAPCAR (http://www.autolisp.mapcar.net) stammen.
; kann auch eine Gemeinschaftsproduktion in ww3.cad.de sein mit Marc Scherer und vielen Anderen.
(princ "Aufruf : poly_trim")
(defun c:1poly_trim ( / )
  	(If (or (not TolL) (not TolW) (not GeoCADPunkt))
	    	(progn
		  (setq TolL (getreal "\n Toleranzlnge angeben [ ca 5-10m ] :" )
		        TolW (getreal "\n Toleranzwinkel angeben [ ca 1-2 gon ] :" ))
		  (initget 0 "Ja Nein")
		  (setq GeoCADPunkt (getKword "\n sollen GeoCAD -Kreuz- eingefgt werden ? (j/N)"))
		 )	
	  	(progn
		  (Princ (strcat "\n Toleranz Lnge :" (rtos TolL 2 2) " m  Toleranz Winkeldifferenz :" (rtos TolW 2 2) " g" ))
		  (initget 0 "Ja Nein")
  		  (setq antw (getKword "\nToleranz ndern ? (j/N) "))
		  (If (= antw "Ja")
		      (progn
		   	(setq TolL (getreal "\n Toleranzlnge angeben :" )
		      	      TolW (getreal "\n Toleranzwinkel angeben :" ))
			(initget 0 "Ja Nein")
			(setq GeoCADPunkt (getKword "\n sollen GeoCAD -Kreuz- eingefgt werden ? (j/N)"))
			)
		    )
		  )
	  )
  	(If (> TolW 3)
	    (setq tolw (getreal "\n ich empfehle Winkel < 3 gon !!")))




	(setq Objekt (car (entsel "\n Linie whlen ::")))
  	(poly_trim Objekt)
  )
(defun c:poly_trim ( / i objekte)
  	(setq i 0)
  	(If (or (not TolL) (not TolW) (not GeoCADPunkt))
		(progn
		  	(setq TolL (getreal "\n Toleranzlnge angeben [ ca 5-10m ] :" )
		      	      TolW (getreal "\n Toleranzwinkel angeben [ ca 1-2 gon ] :" ))
		  	(initget 0 "Ja Nein")
		  	(setq GeoCADPunkt (getKword "\n sollen GeoCAD -Kreuz- eingefgt werden ? (j/N)"))
		  )
	  	(progn
		  (Princ (strcat "\n Toleranz Lnge :" (rtos TolL 2 2) " m  Toleranz Winkeldifferenz :" (rtos TolW 2 2) " g" ))
		  (initget 0 "Ja Nein")
  		  (setq antw (getKword "\nToleranz ndern ? (j/N) "))
		  (If (= antw "Ja")
		   	(progn
			     
			     (setq TolL (getreal "\n Toleranzlnge angeben :" )
		      	      	   TolW (getreal "\n Toleranzwinkel angeben :" ))
				(initget 0 "Ja Nein")
			  	(setq 	GeoCADPunkt (getKword "\n sollen GeoCAD -Kreuz- eingefgt werden ? (j/N)"))
			  )
		    )
		  )
	  )
  	(If (> TolW 3)
	    (setq tolw (getreal "\n ich empfehle Winkel < 3 gon !!")))



	(setq Objekte (ssget))
	
	(while (ssname Objekte i)
  		(setq objekt (ssname Objekte i))
;	(setq Objekt (car (entsel "\n Linie whlen ::")))
  		(poly_trim Objekt)
	  
		(setq i (+ i 1))  
	);ende while
  	(princ)
  )




(defun poly_trim ( Objekt / i  AnzahlSeg Segmente Punkt VorPunkt NeuListe vorwinkel) ; Globale Var : TolL TolW
  	(setq i 1
	      vorwinkel 0)
	;;(setq Objekt (car (entsel "\n Linie whlen ::")))
  	
;;;	(princ "\n Objekt :")
;;;	(princ objekt)
  	(setq Anzahlseg (Count-HW-PL-POINTS objekt))
	(setq segmente  (GET-PL-POINTS objekt))
;;;  	(princ "\n Segmente :")
;;; 	(princ Anzahlseg)
;;;  	(princ "\n")
;;;  	(princ segmente)
  	(setq NeuListe (cons  (nth 0 Segmente) NeuListe)
		VorPunkt (nth 0 Segmente))
  	(repeat (- Anzahlseg 1)
  		(setq Punkt    (nth i Segmente)
		      
		      DiffL (distance Punkt Vorpunkt)
		      DiffW (abs (- vorwinkel (/ (* (angle Punkt Vorpunkt) 200) Pi)))
		      Vorwinkel (/ (* (angle Punkt Vorpunkt) 200) Pi)
		      i (+ i 1))
;;;  		(princ "\n")
;;;  		(princ Punkt)
;;;  		(princ " ")
;;;  		(princ DiffL)
;;;  		(princ " ")
;;;  		(princ DiffW)
	  	(If (> DiffL TolL) 
		  	(setq NeuListe (cons Punkt NeuListe)
			      VorPunkt Punkt
		  	      PP (pkt_einf Punkt "name"))	
		  	(If (> DiffW TolW)
			    (setq NeuListe (cons Punkt NeuListe)
				  PP (pkt_einf Punkt "name")
				  VorPunkt Punkt)
;;;			    (princ "nicht bernommen")
			  
			  )
		  )
	);ende repeat
  	(reverse NeuListe)
  	;(princ NeuListe)

	(PL-COORDINATE-UPDATE objekt NeuLISTe)
	(princ "\n Segmente vorher :")
 	(princ Anzahlseg)
  	(princ "  Segmente nachher :")
  	(setq Anzahlseg (Count-HW-PL-POINTS objekt))
 	(princ Anzahlseg)
  (princ)
  )



;;; Sub Funktionen aus plvert.lsp  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;; Sub-Function fr COUNT-PL-POINTS
;;; Handelt Polylines
(defun COUNT-HW-PL-POINTS ( ENAME / EDATA INDEX)
  (setq ENAME (->ENAME ENAME)
        INDEX 0
  ) ;_ end of setq
  (while (= (cdr (assoc 0 (setq EDATA (entget (entnext ENAME)))))
            "VERTEX"
         ) ;_ end of =
    (setq ENAME (entnext ENAME)
          INDEX (1+ INDEX)
    ) ;_ end of setq
  ) ;_ end of while
) ;_ end of defun
;;; Liste mit Polylinienpunkten zurckgeben.
;;; -> Elementname
;;; <- Punktliste
(defun GET-PL-POINTS ( ENAME /)
  (setq ENAME (->ENAME ENAME))
  (if (= (cdr (assoc 0 (entget ENAME))) "LWPOLYLINE")
    (GET-LW-PL-POINTS ENAME)
    (GET-HW-PL-POINTS ENAME)
  ) ;_ end of if
) ;_ end of defun

;;; Sub-Sub-Function fr "GET-PL-POINTS"
;;; Handling fr POLYLINE
(defun GET-HW-PL-POINTS (ENAME / EDATA PTLISTE)
  (setq ENAME (->ENAME ENAME))
  (while (= (cdr (assoc 0 (setq EDATA (entget (entnext ENAME)))))
            "VERTEX"
         ) ;_ end of =
    (setq PTLISTE (cons (cdr (assoc 10 EDATA)) PTLISTE)
          ENAME   (entnext ENAME)
    ) ;_ end of setq
  ) ;_ end of while
  (reverse PTLISTE)
) ;_ end of defun

;;;(defun GET-LW-PL-POINTS (ENAME / EDATA PTLISTE)
;;;  (setq EDATA (vl-remove-if-not
;;;                (function (lambda (PAIR) (= (car PAIR) 10)))
;;;                (entget ENAME)
;;;              ) ;_ end vl-remove-if-not
;;;  ) ;_ end setq
;;;  (foreach ELEM EDATA
;;;    (setq PTLISTE (cons (vl-remove 10 ELEM) PTLISTE))
;;;  ) ;_ end foreach
;;;  (reverse PTLISTE)
;;;) ;_ end defun

;;; Axels Lsung

;;; Sub-Sub-Function fr "GET-PL-POINTS"
;;; Handling fr LWPOLYLINE
(defun GET-LW-PL-POINTS (ENAME /)
  (setq ENAME (->ENAME ENAME))
  (mapcar 'cdr
          (vl-remove-if-not
            (function
              (lambda (PAIR) (= (car PAIR) 10))
            ) ;_ end of function
            (entget ENAME)
          ) ;_ end of vl-remove-if-not
  ) ;_ end of mapcar
) ;_ end of defun


(defun GET-LINE-POINTS (ENAME /)
  (list (START-PKT? ENAME) (END-PKT? ENAME))
) ;_ end of defun
;;; Funktion gibt Ename zurck, wenn Lisp-Objekt oder vla-Objekt
;;; bergeben worden sind. Ansonsten nil
(defun ->ENAME (ENAME /)
  (cond
    ((= (type ENAME) 'VLA-OBJECT) (vlax-vla-object->ename ENAME))
    ((= (type ENAME) 'ENAME) ENAME)
    (t NIL)
  ) ;_ end of cond
) ;_ end of defun

;;; Funktion gibt vla-Objekt zurck, wenn Lisp-Objekt oder vla-Objekt
;;; bergeben worden sind. Ansonsten nil
(defun ->VLA-OBJECT (ENAME /)
  (cond
    ((= (type ENAME) 'ENAME) (vlax-ename->vla-object ENAME))
    ((= (type ENAME) 'VLA-OBJECT) ENAME)
    (t NIL)
  ) ;_ end of cond
) ;_ end of defun



;;; Funktion schreibt die Koordinaten einer Pline neu
;;; Argumente:
;;; ename	= Lisp-Ename oder vla-object
;;; coordlist	= Lisp-Koordinatenliste like '((294.234 244.654 0.0) (325.782 248.085 0.0)...)
;;;		  (wird in der Funktion in safearray konvertiert...)
(defun PL-COORDINATE-UPDATE (ENAME COORDLIST / CHK ETYP)
  (setq ENAME (->VLA-OBJECT ENAME))
  (if (setq ETYP (IS-PL? ENAME))
    (progn
      (if (= ETYP "LWPOLYLINE")
        (setq COORDLIST (MS:XYZ->XY COORDLIST)) ;_ fr LWPOly aufbereiten
      ) ;_ end of if
      (vlax-put-property
        ENAME
        'COORDINATES
        (MS:POINTLIST->SAFEARRAY COORDLIST)
      ) ;_ end of vlax-put-property
      ENAME
    ) ;_ end of progn
  ) ;_ end of if
) ;_ end of defun

;;; Identifizierung: Ist Ename eine Poyllinie?
;;; -> Elementname
;;; <- "POLYLINE", "LWPOLYLINE" oder nil
(defun IS-PL? (ENAME / RETVAL)
  (if (wcmatch (setq RETVAL (cdr (assoc 0 (entget (->ENAME ENAME)))))
               "*POLYLINE"
      ) ;_ end of wcmatch
    RETVAL
  ) ;_ end of if
) ;_ end of defun

;;; Funktion macht aus 'ner Punktliste in Lisp ((0 0)(10 10)(20 20))
;;; ein Safearray zur Verwendung in VL-Funktionen (z.B. Polylinien)
;;; Retval: Safearray
(defun MS:POINTLIST->SAFEARRAY (PTLIST)
  (setq PTLIST (apply 'append PTLIST))
  (vlax-safearray-fill
    (vlax-make-safearray
      vlax-vbdouble
      (cons 0 (- (length PTLIST) 1))
    ) ;_ end of vlax-make-safearray
    PTLIST
  ) ;_ end of vlax-safearray-fill
) ;_ end of defun


;;; Funktion schneidet die Z-Koordinate ab, wenn vorhanden
(defun MS:XYZ->XY (PTLIST /)
  (mapcar '(lambda (X)
             (if (caddr X)
               (list (car X) (cadr X))
               X
             ) ;_ end of if
           ) ;_ end of lambda
          PTLIST
  ) ;_ end of mapcar
) ;_ end of defun



(defun pkt_einf ( koord name /)
;; wenn Globale var GeoCADPunkt
  (If (= GeoCADPunkt "Ja")
  	(progn
	  	(command "_insert" "Kreuz" koord  "" "" "" " " (rtos (caddr koord) 2 2))
  		(setq Zobj (ENtget (ENTlast)))
		(setq zobj (subst (cons 8 "Punkte") (assoc 8 zobj) zobj))
		(entmod zobj)
	  )
  )

)


;;;;;
(vl-load-com)